// 1280x720 - widescreen
// files: UPDATEW.MIX, WTITLE.PCX, SAVEG_WI.*
program ccgoldhires;
uses crt, dos;

procedure cntin;
var pause: char;
begin
   writeln;
   writeln('Press any key to continue.');
   repeat until keypressed;
    pause:=ReadKey();
end; {cntin}


procedure hackdat;
var
  f:file;
  nr,lang:integer;
  offset:array [1..300] of integer;
  data:array [1..300] of byte;
  teller,status:integer;
  actual:word;
begin
  assign(f,ParamStr(1));
  {$I-}
  reset(f,1);
  status:=IOResult;
  if status<>0 then
   begin
    writeln();
    writeln('Error opening "',ParamStr(1),'"');
   end
  else
   begin
    lang:=0;
    case filesize(f) of
     1161216 : begin write('English'); lang:= 1; end;
     1163776 : begin write('German');  lang:= 2; end;
     1164288 : begin write('French');  lang:= 3; end;
    end;
    if lang=0 then
     begin
      writeln();
      writeln();
      writeln('Incorrect filesize. Cannot identify language.');
     end
    else
     begin
      writeln(' version detected.');
      writeln();
      nr:=0;
      if lang=1 then
      // English
       begin
       write('Patching...');
        // Fix for power bar. The powerbar must still calculate with height of 400 because the menu sprite has fixed height.
        nr:=nr+1;  offset[nr]:=$0007FD08;   data[nr]:=$B9;
        nr:=nr+1;  offset[nr]:=$0007FD09;   data[nr]:=$90;
        nr:=nr+1;  offset[nr]:=$0007FD0A;   data[nr]:=$01;
        nr:=nr+1;  offset[nr]:=$0007FD0B;   data[nr]:=$00;
        nr:=nr+1;  offset[nr]:=$0007FD0C;   data[nr]:=$00;
        nr:=nr+1;  offset[nr]:=$0007FD0D;   data[nr]:=$90;
        nr:=nr+1;  offset[nr]:=$0007FF29;   data[nr]:=$B8;
        nr:=nr+1;  offset[nr]:=$0007FF2A;   data[nr]:=$90;
        nr:=nr+1;  offset[nr]:=$0007FF2B;   data[nr]:=$01;
        nr:=nr+1;  offset[nr]:=$0007FF2C;   data[nr]:=$00;
        // Hardcoded position of Sell button. Calculated as width - 103
        nr:=nr+1;  offset[nr]:=$0009556A;   data[nr]:=$99;
        nr:=nr+1;  offset[nr]:=$0009556B;   data[nr]:=$04;
        // Hardcoded position of Repair button. Calculated as width - 156
        nr:=nr+1;  offset[nr]:=$000955B1;   data[nr]:=$64;
        nr:=nr+1;  offset[nr]:=$000955B2;   data[nr]:=$04;
        // Hardcoded position of Map button. Calculated as width - 50
        nr:=nr+1;  offset[nr]:=$00095676;   data[nr]:=$CE;
        nr:=nr+1;  offset[nr]:=$00095677;   data[nr]:=$04;
        // Hardcoded resolution values.
        nr:=nr+1;  offset[nr]:=$0009A1FE;   data[nr]:=$D0;
        nr:=nr+1;  offset[nr]:=$0009A1FF;   data[nr]:=$02;
        nr:=nr+1;  offset[nr]:=$0009A210;   data[nr]:=$D0;
        nr:=nr+1;  offset[nr]:=$0009A211;   data[nr]:=$02;
        nr:=nr+1;  offset[nr]:=$0009A21E;   data[nr]:=$00;
        nr:=nr+1;  offset[nr]:=$0009A21F;   data[nr]:=$05;
        nr:=nr+1;  offset[nr]:=$0009A22F;   data[nr]:=$D0;
        nr:=nr+1;  offset[nr]:=$0009A230;   data[nr]:=$02;
        nr:=nr+1;  offset[nr]:=$0009A23E;   data[nr]:=$00;
        nr:=nr+1;  offset[nr]:=$0009A23F;   data[nr]:=$05;
        nr:=nr+1;  offset[nr]:=$0009A24A;   data[nr]:=$D0;
        nr:=nr+1;  offset[nr]:=$0009A24B;   data[nr]:=$02;
        nr:=nr+1;  offset[nr]:=$0009A259;   data[nr]:=$00;
        nr:=nr+1;  offset[nr]:=$0009A25A;   data[nr]:=$05;
        nr:=nr+1;  offset[nr]:=$0009A267;   data[nr]:=$D0;
        nr:=nr+1;  offset[nr]:=$0009A268;   data[nr]:=$02;
        nr:=nr+1;  offset[nr]:=$0009A276;   data[nr]:=$00;
        nr:=nr+1;  offset[nr]:=$0009A277;   data[nr]:=$05;
        // Ignore height from options.
        nr:=nr+1;  offset[nr]:=$0009A87D;   data[nr]:=$90;
        nr:=nr+1;  offset[nr]:=$0009A87E;   data[nr]:=$90;
        nr:=nr+1;  offset[nr]:=$0009A87F;   data[nr]:=$90;
        nr:=nr+1;  offset[nr]:=$0009A880;   data[nr]:=$90;
        nr:=nr+1;  offset[nr]:=$0009A881;   data[nr]:=$90;
        // Hardcoded position of tab bar below money counter. Calculated as width - 320
        nr:=nr+1;  offset[nr]:=$0009AF7E;   data[nr]:=$C0;
        nr:=nr+1;  offset[nr]:=$0009AF7F;   data[nr]:=$03;
        // Hardcoded resolution values.
        nr:=nr+1;  offset[nr]:=$000ED36C;   data[nr]:=$00;
        nr:=nr+1;  offset[nr]:=$000ED36D;   data[nr]:=$05;
        nr:=nr+1;  offset[nr]:=$000ED370;   data[nr]:=$D0;
        nr:=nr+1;  offset[nr]:=$000ED371;   data[nr]:=$02;
        // Small maps crash fix.
        nr:=nr+1;  offset[nr]:=$000007A2;   data[nr]:=$A9;
        nr:=nr+1;  offset[nr]:=$000007A3;   data[nr]:=$00;
        nr:=nr+1;  offset[nr]:=$000007A4;   data[nr]:=$C0;
        nr:=nr+1;  offset[nr]:=$000007A6;   data[nr]:=$C0;
        nr:=nr+1;  offset[nr]:=$000007A7;   data[nr]:=$74;
        nr:=nr+1;  offset[nr]:=$000007A8;   data[nr]:=$1B;
        nr:=nr+1;  offset[nr]:=$000007A9;   data[nr]:=$33;
        nr:=nr+1;  offset[nr]:=$000007AA;   data[nr]:=$C0;
        nr:=nr+1;  offset[nr]:=$000007AB;   data[nr]:=$EB;
        nr:=nr+1;  offset[nr]:=$000007AC;   data[nr]:=$17;
        nr:=nr+1;  offset[nr]:=$000007C4;   data[nr]:=$83;
        nr:=nr+1;  offset[nr]:=$000007C5;   data[nr]:=$C4;
        nr:=nr+1;  offset[nr]:=$000007C6;   data[nr]:=$08;
        nr:=nr+1;  offset[nr]:=$000007C7;   data[nr]:=$5F;
        nr:=nr+1;  offset[nr]:=$000007C8;   data[nr]:=$5E;
        nr:=nr+1;  offset[nr]:=$000007C9;   data[nr]:=$59;
        nr:=nr+1;  offset[nr]:=$000007CA;   data[nr]:=$C3;
        nr:=nr+1;  offset[nr]:=$0002472D;   data[nr]:=$E9;
        nr:=nr+1;  offset[nr]:=$0002472E;   data[nr]:=$70;
        nr:=nr+1;  offset[nr]:=$0002472F;   data[nr]:=$C0;
        nr:=nr+1;  offset[nr]:=$00024730;   data[nr]:=$FD;
        nr:=nr+1;  offset[nr]:=$00024731;   data[nr]:=$FF;
        //long sidebar hack: Allocate buffer bigger than 40000 pixels
        nr:=nr+1;  offset[nr]:=$000443E5;   data[nr]:=$FF;
        nr:=nr+1;  offset[nr]:=$000443E6;   data[nr]:=$FF;
        nr:=nr+1;  offset[nr]:=$000443E7;   data[nr]:=$F0;
        nr:=nr+1;  offset[nr]:=$000443EA;   data[nr]:=$FF;
        nr:=nr+1;  offset[nr]:=$000443EB;   data[nr]:=$FF;
        nr:=nr+1;  offset[nr]:=$000443EC;   data[nr]:=$F0;
        //long sidebar hack: Allow width * height to be bigger than 65535
        nr:=nr+1;  offset[nr]:=$00056010;   data[nr]:=$8B;
        nr:=nr+1;  offset[nr]:=$00056011;   data[nr]:=$55;
        nr:=nr+1;  offset[nr]:=$00056012;   data[nr]:=$76;
        nr:=nr+1;  offset[nr]:=$00056013;   data[nr]:=$90;
        // changing UPDATEC.MIX to UPDATEW.MIX
        nr:=nr+1;  offset[nr]:=$000DB898;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DB8A5;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DB8B1;   data[nr]:=$57;
        // changing HTITLE.PCX to WTITLE.PCX
        nr:=nr+1;  offset[nr]:=$000DACA9;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DBCE7;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DBD26;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DC95C;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DC967;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DC972;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DCB0A;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DD018;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DD13C;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DD65A;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DD665;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DD6D6;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DD74C;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DD75A;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DD77A;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DD89E;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DD95D;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DDA0F;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DDA9C;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DDB65;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DDBC4;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DDBD0;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DDBE8;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DDBF3;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DDC9C;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DDCD2;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DDD0E;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DDD59;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DDD65;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DDDB5;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DDDEE;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DDE1C;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DDF11;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DDF3A;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DE11D;   data[nr]:=$57;
        // changing savegames from SAVEGAME.* to SAVEG_WI.*
        nr:=nr+1;  offset[nr]:=$000DCB1A;   data[nr]:=$5F;
        nr:=nr+1;  offset[nr]:=$000DCB1B;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DCB1C;   data[nr]:=$49;
        nr:=nr+1;  offset[nr]:=$000DCB28;   data[nr]:=$5F;
        nr:=nr+1;  offset[nr]:=$000DCB29;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DCB2A;   data[nr]:=$49;
        nr:=nr+1;  offset[nr]:=$000DF861;   data[nr]:=$5F;
        nr:=nr+1;  offset[nr]:=$000DF862;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DF863;   data[nr]:=$49;
        nr:=nr+1;  offset[nr]:=$000DF874;   data[nr]:=$5F;
        nr:=nr+1;  offset[nr]:=$000DF875;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DF876;   data[nr]:=$49;
        nr:=nr+1;  offset[nr]:=$000DF882;   data[nr]:=$5F;
        nr:=nr+1;  offset[nr]:=$000DF883;   data[nr]:=$57;
        nr:=nr+1;  offset[nr]:=$000DF884;   data[nr]:=$49;
       end
      else if lang=2 then
      // German
       begin
        writeln('<< NOT IMPLEMENTED YET>>');
       end
      else if lang=3 then
      // French
       begin
        writeln('<< NOT IMPLEMENTED YET>>');
       end;
      //writing
      for teller:=1 to nr do
       begin
        seek(f,offset[teller]);
        blockwrite(f,data[teller],1,actual);
       end;
      close(f);
      {$I+}
      if lang=1 then writeln(' Done');
     end;
   end;
end; {hackdat}

begin
  writeln('Command & Conquer Gold hi-res Patch                 Hack developed by komfr');
  writeln('-----------------------------------                 Program written by Nyerguds');
  writeln();
   if ParamCount = 0 then
    begin
     writeln();
     writeln('To play C&C95 in 1280x720 resolution, drop a copy of C&C95.exe onto the icon');
     writeln('of this program to patch it, and copy the included file UPDATEX.MIX to your');
     writeln('C&C95 directory.');
     writeln();
     writeln('Note that savegames of the normal C&C95 can''t be used in the hi-res version');
     writeln('because the sidebar becomes unusable. For this reason, the samegame files of');
     writeln('the low-res version will not show up in the list of the hi-res version, and');
     writeln('vice versa.');
     writeln();
    end
   else hackdat;
  cntin;
end.



